package run.evan.hotspotip;

import java.lang.reflect.Constructor;
import java.lang.reflect.Method;

import de.robv.android.xposed.IXposedHookLoadPackage;
import de.robv.android.xposed.XC_MethodHook;
import de.robv.android.xposed.XSharedPreferences;
import de.robv.android.xposed.XposedBridge;
import de.robv.android.xposed.XposedHelpers;
import de.robv.android.xposed.callbacks.XC_LoadPackage;

public class MainHook implements IXposedHookLoadPackage {



    @Override
    public void handleLoadPackage(XC_LoadPackage.LoadPackageParam loadPackageParam) throws Throwable {
        if (loadPackageParam.packageName.equals("com.android.networkstack.tethering.inprocess")) {
            XSharedPreferences prefs = new XSharedPreferences("run.evan.hotspotip", "conf");
            XposedBridge.log("Hotspot Ip init");
            XposedHelpers.findAndHookMethod("com.android.networkstack.tethering.PrivateAddressCoordinator", loadPackageParam.classLoader, "requestDownstreamAddress", "android.net.ip.IpServer", boolean.class, new XC_MethodHook() {

                @Override
                protected void afterHookedMethod(MethodHookParam param) throws Throwable {
                    prefs.reload();
                    Class linkAddressClass = XposedHelpers.findClass("android.net.LinkAddress", loadPackageParam.classLoader);
                    Constructor linkAddressConstructor = linkAddressClass.getConstructor(String.class);
                    Class ipServerClass = XposedHelpers.findClass("android.net.ip.IpServer", loadPackageParam.classLoader);
                    Method interfaceTypeMethod = ipServerClass.getDeclaredMethod("interfaceType");
                    int iFaceType = (int) interfaceTypeMethod.invoke(param.args[0]);
                    XposedBridge.log("Hotspot Ip process ifaceType=" + iFaceType);
                    XposedBridge.log(prefs.getString("usb_ip", "192.168.7.2/24"));
                    if (prefs.getBoolean("wlan_persistent_enable", true)) {
                        XposedBridge.log("Hotspot Ip fixed wlanA");
                        param.setResult(linkAddressConstructor.newInstance("192.168.6.1/24"));
                    }else {
                        XposedBridge.log("Hotspot Ip fixed wlan not enable");
                    }
//                    switch (iFaceType) {
//                        case 0:
//                            if (prefs.getBoolean("wlan_persistent_enable", true)) {
//                                XposedBridge.log("Hotspot Ip fixed wlan");
//                                param.setResult(linkAddressConstructor.newInstance("192.168.6.1/24"));
//                            }else {
//                                XposedBridge.log("Hotspot Ip fixed wlan not enable");
//                            }
//                        case 1:
//                            if (prefs.getBoolean("usb_persistent_enable", true)) {
//                                param.setResult(linkAddressConstructor.newInstance(prefs.getString("usb_ip", "192.168.7.1/24")));
//                            }
//                        case 2:
//                            if (prefs.getBoolean("bluetooth_persistent_enable", true)) {
//                                param.setResult(linkAddressConstructor.newInstance(prefs.getString("usb_ip", "192.168.8.1/24")));
//                            }
//                        default:
//                            //super.afterHookedMethod(param);
//
//                    }
                }
//
//                @Override
//                protected Object replaceHookedMethod(MethodHookParam methodHookParam) throws Throwable {
//                    Class linkAddressClass = XposedHelpers.findClass("android.net.LinkAddress", loadPackageParam.classLoader);
//                    Constructor linkAddressConstructor = linkAddressClass.getConstructor(String.class);
//                    Class ipServerClass = XposedHelpers.findClass("android.net.ip.IpServer", loadPackageParam.classLoader);
//                    Method interfaceTypeMethod = ipServerClass.getDeclaredMethod("interfaceType");
//                    int iFaceType = (int) interfaceTypeMethod.invoke(methodHookParam.args[0]);
//                    switch (iFaceType) {
//                        case 3:
//                            return linkAddressConstructor.newInstance("192.168.49.1/24");
//                        case 0:
//                            return linkAddressConstructor.newInstance("192.168.6.1/24");
//                        case 1:
//                            return linkAddressConstructor.newInstance("192.168.7.1/24");
//                        default:
//                            return linkAddressConstructor.newInstance("192.168.8.1/24");
//                    }
//                }
            });
        }
    }
}
